Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Text

Public Class USB_Serial

#Region "API Region"
    Const GENERIC_WRITE As Integer = &H40000000
    Const FILE_SHARE_READ As Integer = &H1
    Const FILE_SHARE_WRITE As Integer = &H2
    Const OPEN_EXISTING As Integer = &H3
    Const INVALID_HANDLE_VALUE As Integer = -1

    Const USB_DEVICE_DESCRIPTOR_TYPE As Integer = &H1
    Const USB_STRING_DESCRIPTOR_TYPE As Integer = &H3
    Const IOCTL_USB_GET_DESCRIPTOR_FROM_NODE_CONNECTION As Integer = &H220410
    Const IOCTL_STORAGE_GET_DEVICE_NUMBER As Integer = &H2D1080
    Const IOCTL_USB_GET_NODE_CONNECTION_DRIVERKEY_NAME As Integer = &H220420
    Const IOCTL_USB_GET_NODE_INFORMATION As Integer = &H220408
    Const IOCTL_USB_GET_NODE_CONNECTION_INFORMATION_EX As Integer = &H220448

    Const GUID_DEVINTERFACE_DISK As String = "53f56307-b6bf-11d0-94f2-00a0c91efb8b"
    Const GUID_DEVINTERFACE_USB_HUB As String = "f18a0e88-c30c-11d0-8815-00a0c906bed8"
    Const SPDRP_DRIVER As Integer = 9
    Const SPDRP_DEVICEDESC As Integer = 0
    Const REG_SZ As Integer = 1
    Const DIGCF_ALLCLASSES As Integer = &H4
    Const DIGCF_PRESENT As Integer = &H2
    Const DIGCF_DEVICEINTERFACE As Integer = &H10
    Const REGSTR_KEY_USB As String = "USB"

    Const MAXIMUM_USB_STRING_LENGTH As Integer = 255
    Const BUFFER_SIZE As Integer = 2048

    'typedef enum _USB_HUB_NODE {
    '    UsbHub,
    '    UsbMIParent
    '} USB_HUB_NODE;
    Private Enum USB_HUB_NODE As Integer
        UsbHub
        UsbMIParent
    End Enum

    'typedef enum _USB_CONNECTION_STATUS {
    '    NoDeviceConnected,
    '    DeviceConnected,
    '    DeviceFailedEnumeration,
    '    DeviceGeneralFailure,
    '    DeviceCausedOvercurrent,
    '    DeviceNotEnoughPower,
    '    DeviceNotEnoughBandwidth,
    '    DeviceHubNestedTooDeeply,
    '    DeviceInLegacyHub
    '} USB_CONNECTION_STATUS, *PUSB_CONNECTION_STATUS;
    Private Enum USB_CONNECTION_STATUS As Integer
        NoDeviceConnected
        DeviceConnected
        DeviceFailedEnumeration
        DeviceGeneralFailure
        DeviceCausedOvercurrent
        DeviceNotEnoughPower
        DeviceNotEnoughBandwidth
        DeviceHubNestedTooDeeply
        DeviceInLegacyHub
    End Enum

    'typedef struct _USB_HUB_DESCRIPTOR {
    '    UCHAR  bDescriptorLength;
    '    UCHAR  bDescriptorType;
    '    UCHAR  bNumberOfPorts;
    '    USHORT  wHubCharacteristics;
    '    UCHAR  bPowerOnToPowerGood;
    '    UCHAR  bHubControlCurrent;
    '    UCHAR  bRemoveAndPowerMask[64];
    '} USB_HUB_DESCRIPTOR, *PUSB_HUB_DESCRIPTOR;
    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Private Structure USB_HUB_DESCRIPTOR
        Dim bDescriptorLength As Byte
        Dim bDescriptorType As Byte
        Dim bNumberOfPorts As Byte
        Dim wHubCharacteristics As Short
        Dim bPowerOnToPowerGood As Byte
        Dim bHubControlCurrent As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
        Dim bRemoveAndPowerMask() As Byte
    End Structure

    'typedef struct _USB_HUB_INFORMATION {
    '    USB_HUB_DESCRIPTOR HubDescriptor;
    '    BOOLEAN HubIsBusPowered;
    '} USB_HUB_INFORMATION, *PUSB_HUB_INFORMATION;
    <StructLayout(LayoutKind.Sequential)> _
    Private Structure USB_HUB_INFORMATION
        Dim HubDescriptor As USB_HUB_DESCRIPTOR
        Dim HubIsBusPowered As Byte
    End Structure

    'typedef struct _USB_NODE_INFORMATION {
    '    USB_HUB_NODE  NodeType;
    '    union {
    '        USB_HUB_INFORMATION  HubInformation;
    '        USB_MI_PARENT_INFORMATION  MiParentInformation;
    '    } u;
    '} USB_NODE_INFORMATION, *PUSB_NODE_INFORMATION;
    <StructLayout(LayoutKind.Sequential)> _
    Private Structure USB_NODE_INFORMATION
        Dim NodeType As Integer
        Dim HubInformation As USB_HUB_INFORMATION
    End Structure

    'typedef struct _USB_DESCRIPTOR_REQUEST {
    '  ULONG ConnectionIndex;
    '  struct {
    '    UCHAR  bmRequest;
    '    UCHAR  bRequest;
    '    USHORT  wValue;
    '    USHORT  wIndex;
    '    USHORT  wLength;
    '  } SetupPacket;
    '  UCHAR  Data[0];
    '} USB_DESCRIPTOR_REQUEST, *PUSB_DESCRIPTOR_REQUEST
    <StructLayout(LayoutKind.Sequential)> _
    Private Structure USB_SETUP_PACKET
        Dim bmRequest As Byte
        Dim bRequest As Byte
        Dim wValue As Short
        Dim wIndex As Short
        Dim wLength As Short
    End Structure
    <StructLayout(LayoutKind.Sequential)> _
    Private Structure USB_DESCRIPTOR_REQUEST
        Dim ConnectionIndex As Integer
        Dim SetupPacket As USB_SETUP_PACKET
        'Dim Data() As Byte
    End Structure

    'typedef struct _USB_DEVICE_DESCRIPTOR {
    '  UCHAR  bLength;
    '  UCHAR  bDescriptorType;
    '  USHORT  bcdUSB;
    '  UCHAR  bDeviceClass;
    '  UCHAR  bDeviceSubClass;
    '  UCHAR  bDeviceProtocol;
    '  UCHAR  bMaxPacketSize0;
    '  USHORT  idVendor;
    '  USHORT  idProduct;
    '  USHORT  bcdDevice;
    '  UCHAR  iManufacturer;
    '  UCHAR  iProduct;
    '  UCHAR  iSerialNumber;
    '  UCHAR  bNumConfigurations;
    '} USB_DEVICE_DESCRIPTOR, *PUSB_DEVICE_DESCRIPTOR ;
    <StructLayout(LayoutKind.Sequential, pack:=1)> _
    Private Structure USB_DEVICE_DESCRIPTOR
        Dim bLength As Byte
        Dim bDescriptorType As Byte
        Dim bcdUSB As Short
        Dim bDeviceClass As Byte
        Dim bDeviceSubClass As Byte
        Dim bDeviceProtocol As Byte
        Dim bMaxPacketSize0 As Byte
        Dim idVendor As Short
        Dim idProduct As Short
        Dim bcdDevice As Short
        Dim iManufacturer As Byte
        Dim iProduct As Byte
        Dim iSerialNumber As Byte
        Dim bNumConfigurations As Byte
    End Structure

    'typedef struct _USB_NODE_CONNECTION_INFORMATION_EX {
    '    ULONG  ConnectionIndex;
    '    USB_DEVICE_DESCRIPTOR  DeviceDescriptor;
    '    UCHAR  CurrentConfigurationValue;
    '    UCHAR  Speed;
    '    BOOLEAN  DeviceIsHub;
    '    USHORT  DeviceAddress;
    '    ULONG  NumberOfOpenPipes;
    '    USB_CONNECTION_STATUS  ConnectionStatus;
    '    USB_PIPE_INFO  PipeList[0];
    '} USB_NODE_CONNECTION_INFORMATION_EX, *PUSB_NODE_CONNECTION_INFORMATION_EX;
    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Private Structure USB_NODE_CONNECTION_INFORMATION_EX
        Dim ConnectionIndex As Integer
        Dim DeviceDescriptor As USB_DEVICE_DESCRIPTOR
        Dim CurrentConfigurationValue As Byte
        Dim Speed As Byte
        Dim DeviceIsHub As Byte
        Dim DeviceAddress As Short
        Dim NumberOfOpenPipes As Integer
        Dim ConnectionStatus As Integer
        'Dim PipeList as IntPtr
    End Structure

    'typedef struct _USB_STRING_DESCRIPTOR {
    '    UCHAR bLength;
    '    UCHAR bDescriptorType;
    '    WCHAR bString[1];
    '} USB_STRING_DESCRIPTOR, *PUSB_STRING_DESCRIPTOR;
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> _
    Private Structure USB_STRING_DESCRIPTOR
        Dim bLength As Byte
        Dim bDescriptorType As Byte
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MAXIMUM_USB_STRING_LENGTH)> Dim bString As String
    End Structure

    'typedef struct _USB_NODE_CONNECTION_DRIVERKEY_NAME {
    '  ULONG  ConnectionIndex;
    '  ULONG  ActualLength;
    '  WCHAR  DriverKeyName[1];
    '} USB_NODE_CONNECTION_DRIVERKEY_NAME, *PUSB_NODE_CONNECTION_DRIVERKEY_NAME;
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> _
    Private Structure USB_NODE_CONNECTION_DRIVERKEY_NAME
        Dim ConnectionIndex As Integer
        Dim ActualLength As Integer
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=BUFFER_SIZE)> Dim DriverKeyName As String
    End Structure

    'typedef struct _STORAGE_DEVICE_NUMBER {
    '  DEVICE_TYPE  DeviceType;
    '  ULONG  DeviceNumber;
    '  ULONG  PartitionNumber;
    '} STORAGE_DEVICE_NUMBER, *PSTORAGE_DEVICE_NUMBER;
    <StructLayout(LayoutKind.Sequential)> _
    Private Structure STORAGE_DEVICE_NUMBER
        Dim DeviceType As Integer
        Dim DeviceNumber As Integer
        Dim PartitionNumber As Integer
    End Structure

    'typedef struct _SP_DEVINFO_DATA {
    '  DWORD cbSize;
    '  GUID ClassGuid;
    '  DWORD DevInst;
    '  ULONG_PTR Reserved;
    '} SP_DEVINFO_DATA,  *PSP_DEVINFO_DATA;
    <StructLayout(LayoutKind.Sequential)> _
    Private Structure SP_DEVINFO_DATA
        Dim cbSize As Integer
        Dim ClassGuid As Guid
        Dim DevInst As IntPtr
        Dim Reserved As Integer
    End Structure

    'typedef struct _SP_DEVICE_INTERFACE_DATA {
    '  DWORD cbSize;
    '  GUID InterfaceClassGuid;
    '  DWORD Flags;
    '  ULONG_PTR Reserved;
    '} SP_DEVICE_INTERFACE_DATA,  *PSP_DEVICE_INTERFACE_DATA;
    <StructLayout(LayoutKind.Sequential)> _
    Private Structure SP_DEVICE_INTERFACE_DATA
        Dim cbSize As Integer
        Dim InterfaceClassGuid As Guid
        Dim Flags As Integer
        Dim Reserved As IntPtr
    End Structure

    'typedef struct _SP_DEVICE_INTERFACE_DETAIL_DATA {
    '  DWORD cbSize;
    '  TCHAR DevicePath[ANYSIZE_ARRAY];
    '} SP_DEVICE_INTERFACE_DETAIL_DATA,  *PSP_DEVICE_INTERFACE_DETAIL_DATA;
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> _
    Private Structure SP_DEVICE_INTERFACE_DETAIL_DATA
        Dim cbSize As Integer
        'Dim DevicePath As IntPtr
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=BUFFER_SIZE)> Dim DevicePath As String
    End Structure

    'CMAPI CONFIGRET WINAPI  CM_Get_Parent(
    '   OUT PDEVINST  pdnDevInst,
    '   IN DEVINST  dnDevInst,
    '   IN ULONG  ulFlags
    ');
    Private Declare Auto Function CM_Get_Parent Lib "setupapi.dll" ( _
        ByRef pdnDevInst As IntPtr, _
        ByVal dnDevInst As IntPtr, _
        ByVal ulFlags As Integer _
    ) As Integer

    'CMAPI CONFIGRET WINAPI  CM_Get_Device_ID(
    '    IN DEVINST  dnDevInst,
    '    OUT PTCHAR  Buffer,
    '    IN ULONG  BufferLen,
    '    IN ULONG  ulFlags
    ');
    Private Declare Auto Function CM_Get_Device_ID Lib "setupapi.dll" ( _
        ByVal pdnDevInst As IntPtr, _
        ByVal Buffer As IntPtr, _
        ByVal BufferLen As Integer, _
        ByVal ulFlags As Integer _
    ) As Integer

    'HANDLE CreateFile(
    '  LPCTSTR lpFileName,
    '  DWORD dwDesiredAccess,
    '  DWORD dwShareMode,
    '  LPSECURITY_ATTRIBUTES lpSecurityAttributes,
    '  DWORD dwCreationDisposition,
    '  DWORD dwFlagsAndAttributes,
    '  HANDLE hTemplateFile
    ');
    Private Declare Auto Function CreateFile Lib "kernel32" ( _
        ByVal lpFileName As String, _
        ByVal dwDesiredAccess As Integer, _
        ByVal dwShareMode As Integer, _
        ByVal lpSecurityAttributes As IntPtr, _
        ByVal dwCreationDisposition As Integer, _
        ByVal dwFlagsAndAttributes As Integer, _
        ByVal hTemplateFile As IntPtr _
    ) As IntPtr

    'BOOL CloseHandle(
    '  HANDLE hObject
    ');
    Private Declare Function CloseHandle Lib "kernel32" ( _
        ByVal hObject As IntPtr _
    ) As Boolean

    'BOOL DeviceIoControl(
    '  HANDLE hDevice,
    '  DWORD dwIoControlCode,
    '  LPVOID lpInBuffer,
    '  DWORD nInBufferSize,
    '  LPVOID lpOutBuffer,
    '  DWORD nOutBufferSize,
    '  LPDWORD lpBytesReturned,
    '  LPOVERLAPPED lpOverlapped
    ');
    Private Declare Unicode Function DeviceIoControl Lib "kernel32" ( _
        ByVal hDevice As IntPtr, _
        ByVal dwIoControlCode As Integer, _
        ByVal lpInBuffer As IntPtr, _
        ByVal nInBufferSize As Integer, _
        ByVal lpOutBuffer As IntPtr, _
        ByVal nOutBufferSize As Integer, _
        ByRef lpBytesReturned As Integer, _
        ByVal lpOverlapped As IntPtr _
    ) As Boolean

    'HDEVINFO SetupDiGetClassDevs(
    '  const GUID* ClassGuid,
    '  PCTSTR Enumerator,
    '  HWND hwndParent,
    '  DWORD Flags
    ');
    Private Declare Auto Function SetupDiGetClassDevs Lib "setupapi.dll" ( _
        ByRef ClassGuid As Guid, _
        ByVal Enumerator As Integer, _
        ByVal hwndParent As IntPtr, _
        ByVal Flags As Integer _
    ) As IntPtr
    Private Declare Auto Function SetupDiGetClassDevs Lib "setupapi.dll" ( _
        ByRef ClassGuid As Integer, _
        ByVal Enumerator As String, _
        ByVal hwndParent As IntPtr, _
        ByVal Flags As Integer _
    ) As IntPtr

    'BOOL SetupDiEnumDeviceInterfaces(
    '  HDEVINFO DeviceInfoSet,
    '  PSP_DEVINFO_DATA DeviceInfoData,
    '  const GUID* InterfaceClassGuid,
    '  DWORD MemberIndex,
    '  PSP_DEVICE_INTERFACE_DATA DeviceInterfaceData
    ');
    Private Declare Auto Function SetupDiEnumDeviceInterfaces Lib "setupapi.dll" ( _
        ByVal DeviceInfoSet As IntPtr, _
        ByVal DeviceInfoData As IntPtr, _
        ByRef InterfaceClassGuid As Guid, _
        ByVal MemberIndex As Integer, _
        ByRef DeviceInterfaceData As SP_DEVICE_INTERFACE_DATA _
    ) As Boolean

    'BOOL SetupDiGetDeviceInterfaceDetail(
    '  HDEVINFO DeviceInfoSet,
    '  PSP_DEVICE_INTERFACE_DATA DeviceInterfaceData,
    '  PSP_DEVICE_INTERFACE_DETAIL_DATA DeviceInterfaceDetailData,
    '  DWORD DeviceInterfaceDetailDataSize,
    '  PDWORD RequiredSize,
    '  PSP_DEVINFO_DATA DeviceInfoData
    ');
    Private Declare Auto Function SetupDiGetDeviceInterfaceDetail Lib "setupapi.dll" ( _
        ByVal DeviceInfoSet As IntPtr, _
        ByRef DeviceInterfaceData As SP_DEVICE_INTERFACE_DATA, _
        ByRef DeviceInterfaceDetailData As SP_DEVICE_INTERFACE_DETAIL_DATA, _
        ByVal DeviceInterfaceDetailDataSize As Integer, _
        ByRef RequiredSize As Integer, _
        ByRef DeviceInfoData As SP_DEVINFO_DATA _
    ) As Boolean

    'WINSETUPAPI BOOL WINAPI  SetupDiGetDeviceInstanceId(
    '    IN HDEVINFO  DeviceInfoSet,
    '    IN PSP_DEVINFO_DATA  DeviceInfoData,
    '    OUT PTSTR  DeviceInstanceId,
    '    IN DWORD  DeviceInstanceIdSize,
    '    OUT PDWORD  RequiredSize  OPTIONAL
    ');
    Private Declare Auto Function SetupDiGetDeviceInstanceId Lib "setupapi.dll" ( _
        ByVal DeviceInfoSet As IntPtr, _
        ByRef DeviceInfoData As SP_DEVINFO_DATA, _
        ByVal DeviceInstanceId As StringBuilder, _
        ByVal DeviceInstanceIdSize As Integer, _
        ByRef RequiredSize As Integer _
    ) As Boolean

    'BOOL SetupDiEnumDeviceInfo(
    '  HDEVINFO DeviceInfoSet,
    '  DWORD MemberIndex,
    '  PSP_DEVINFO_DATA DeviceInfoData
    ');
    Private Declare Auto Function SetupDiEnumDeviceInfo Lib "setupapi.dll" ( _
        ByVal DeviceInfoSet As IntPtr, _
        ByVal MemberIndex As Integer, _
        ByRef DeviceInfoData As SP_DEVINFO_DATA _
    ) As Boolean

    'BOOL SetupDiGetDeviceRegistryProperty(
    '  HDEVINFO DeviceInfoSet,
    '  PSP_DEVINFO_DATA DeviceInfoData,
    '  DWORD Property,
    '  PDWORD PropertyRegDataType,
    '  PBYTE PropertyBuffer,
    '  DWORD PropertyBufferSize,
    '  PDWORD RequiredSize
    ');
    Private Declare Auto Function SetupDiGetDeviceRegistryProperty Lib "setupapi.dll" ( _
        ByVal DeviceInfoSet As IntPtr, _
        ByRef DeviceInfoData As SP_DEVINFO_DATA, _
        ByVal iProperty As Integer, _
        ByRef PropertyRegDataType As Integer, _
        ByVal PropertyBuffer As IntPtr, _
        ByVal PropertyBufferSize As Integer, _
        ByRef RequiredSize As Integer _
    ) As Boolean

    'BOOL SetupDiDestroyDeviceInfoList(
    '  HDEVINFO DeviceInfoSet
    ');
    Private Declare Function SetupDiDestroyDeviceInfoList Lib "setupapi.dll" ( _
        ByVal DeviceInfoSet As IntPtr _
    ) As Boolean
#End Region

    '
    ' To get the serial number from a USB storage device, we need to take the 
    ' following steps:
    '   Step1: Find the correct disk device in the "device tree" by searching for a unique device number
    '   Step2: Get the InstanceID of the device and "walk the device tree" upwards to get the DevicePath of the Hub
    '   Step3: Loop thru each of the ports on the Hub to find the matching InstanceID
    '   Step4: Get the iSerialNumber "index" from the DeviceDescriptor
    '   Step5: Get the string value for StringDescriptor
    '
    Function GetSerialNumber(ByVal DriveLetter As String) As String
        Dim SerialNumber As String = ""
        Dim InstanceID As String = ""
        Dim HubDevicePath As String = ""
        Dim HubPortCount As Integer

        ' HubDevicePath and InstanceID are passed by reference
        If Not FindDiskDevice(DriveLetter, HubDevicePath, InstanceID) Then
            Throw New ApplicationException("Can't find the device instance")
        End If
        If Not InstanceID.StartsWith("USB\") Then
            Throw New ApplicationException("This drive doesn't appear to be a USB device")
        End If

        ' how many ports are there?
        HubPortCount = GetPortCount(HubDevicePath)
        If HubPortCount = 0 Then
            Throw New ApplicationException("Can't get the number of ports on the hub")
        End If

        ' loop thru all of the ports hunting for a matching InstanceID
        ' BTW: Port numbers start at 1
        For i As Integer = 1 To HubPortCount
            ' does the device match the InstanceID we're looking for?
            If FindInstanceIDByKeyName(GetDriverKeyName(HubDevicePath, i)) = InstanceID Then

                ' get the "index" for the serial number
                Dim DeviceDescriptor As USB_DEVICE_DESCRIPTOR = GetDeviceDescriptor(HubDevicePath, i)

                ' a iSerialNumber of 0 means there is no serial number
                If DeviceDescriptor.iSerialNumber > 0 Then
                    SerialNumber = GetStringDescriptor(HubDevicePath, i, DeviceDescriptor.iSerialNumber)
                    Exit For
                End If
            End If
        Next

        Return SerialNumber
    End Function

    '
    ' An interal routine to get the unique "Device Number" 
    ' Used in Step 1
    '
    Private Function GetDeviceNumber(ByVal DevicePath As String) As Integer
        Dim ans As Integer = -1

        Dim h As IntPtr = CreateFile(DevicePath.TrimEnd("\"c), 0, 0, Nothing, OPEN_EXISTING, 0, Nothing)
        If h.ToInt32 <> INVALID_HANDLE_VALUE Then
            Dim reqSize As Integer = 0
            Dim Sdn As New STORAGE_DEVICE_NUMBER
            Dim nBytes As Integer = Marshal.SizeOf(Sdn)
            Dim ptrSdn As IntPtr = Marshal.AllocHGlobal(nBytes)

            If DeviceIoControl(h, IOCTL_STORAGE_GET_DEVICE_NUMBER, IntPtr.Zero, 0, ptrSdn, Marshal.SizeOf(Sdn), reqSize, Nothing) Then
                Sdn = CType(Marshal.PtrToStructure(ptrSdn, GetType(STORAGE_DEVICE_NUMBER)), STORAGE_DEVICE_NUMBER)
                ' just my way of combining the relevant parts of the
                ' STORAGE_DEVICE_NUMBER into a single number
                ans = (Sdn.DeviceType << 8) + Sdn.DeviceNumber
            End If
            Marshal.FreeHGlobal(ptrSdn)
            CloseHandle(h)
        End If

        Return ans
    End Function

    '
    ' An internal routine to get the HubDevicePath and InstanceID
    ' Handles Step 1 and Step 2
    '
    Private Function FindDiskDevice(ByVal DriveLetter As String, ByRef HubDevicePath As String, ByRef InstanceID As String) As Boolean
        Dim ans As Boolean = False

        ' Get the DeviceNumber using the drive letter (without a trailing 
        ' backslash, ie "C:").  We'll use this later to match the DeviceNumber
        ' of each of the device's Symbolic Name 
        Dim DeviceNumber As Integer = GetDeviceNumber("\\.\" & DriveLetter.TrimEnd("\"c))
        If DeviceNumber < 0 Then
            Return ans
        End If

        Dim DiskGUID As New Guid(GUID_DEVINTERFACE_DISK)

        ' We start at the "root" of the device tree and look for all
        ' devices that match the interface GUID of a disk
        Dim hSetup As IntPtr = SetupDiGetClassDevs(DiskGUID, 0, IntPtr.Zero, DIGCF_PRESENT Or DIGCF_DEVICEINTERFACE)
        If hSetup.ToInt32 <> INVALID_HANDLE_VALUE Then

            Dim Success As Boolean
            Dim i As Integer = 0
            Do
                ' create a Device Interface Data structure
                Dim dia As New SP_DEVICE_INTERFACE_DATA
                dia.cbSize = Marshal.SizeOf(dia)

                ' start the enumeration 
                Success = SetupDiEnumDeviceInterfaces(hSetup, IntPtr.Zero, DiskGUID, i, dia)
                If Success Then
                    ' prepare a Devinfo Data structure
                    Dim da As New SP_DEVINFO_DATA
                    da.cbSize = Marshal.SizeOf(da)

                    ' prepare a Device Interface Detail Data structure
                    Dim didd As New SP_DEVICE_INTERFACE_DETAIL_DATA
                    didd.cbSize = 4 + Marshal.SystemDefaultCharSize ' trust me :)

                    ' now we can get some more detailed information
                    Dim nBytes As Integer = BUFFER_SIZE
                    Dim nRequiredSize As Integer = 0
                    If SetupDiGetDeviceInterfaceDetail(hSetup, dia, didd, nBytes, nRequiredSize, da) Then

                        ' OK, let's get the Device Number again... this time using
                        ' the device's "Symbolic Name".  If the numbers match, we've
                        ' found the one we're looking for.
                        If GetDeviceNumber(didd.DevicePath) = DeviceNumber Then

                            ' This should get us to the USBSTOR "level"
                            Dim ptrPrevious As IntPtr
                            CM_Get_Parent(ptrPrevious, da.DevInst, 0)

                            ' Get the InstanceID
                            Dim ptrBuf As IntPtr = Marshal.AllocHGlobal(nBytes)
                            CM_Get_Device_ID(ptrPrevious, ptrBuf, nBytes, 0)
                            InstanceID = Marshal.PtrToStringAuto(ptrBuf)

                            ' This should get us to the USB "level" (the USB hub)
                            CM_Get_Parent(ptrPrevious, ptrPrevious, 0)

                            ' Now get the ID of the hub
                            CM_Get_Device_ID(ptrPrevious, ptrBuf, nBytes, 0)
                            Dim temp As String = Marshal.PtrToStringAuto(ptrBuf)
                            Marshal.FreeHGlobal(ptrBuf)

                            ' Build the final string that represents the full "Symbolic Name"
                            ' of the USB Hub using its ID
                            HubDevicePath = "\\.\" & temp.Replace("\", "#") & "#{" & GUID_DEVINTERFACE_USB_HUB & "}"
                            ans = True
                            Exit Do
                        End If
                    End If
                End If
                i += 1
            Loop While Success
        End If

        SetupDiDestroyDeviceInfoList(hSetup)
        Return ans
    End Function

    '
    ' An internal routine to find DriverKeyName of a connected device
    ' Handles Step 3
    '
    Private Function GetDriverKeyName(ByVal HubPath As String, ByVal PortNumber As Integer) As String
        Dim ans As String = ""

        ' open a handle to the USB hub
        Dim hHub As IntPtr = CreateFile(HubPath, GENERIC_WRITE, FILE_SHARE_WRITE, IntPtr.Zero, OPEN_EXISTING, 0, IntPtr.Zero)
        If hHub.ToInt32 <> INVALID_HANDLE_VALUE Then
            Dim nBytesReturned As Integer
            Dim nBytes As Integer = Marshal.SizeOf(GetType(USB_NODE_CONNECTION_INFORMATION_EX))
            Dim ptrNodeConnection As IntPtr = Marshal.AllocHGlobal(nBytes)

            Dim NodeConnection As New USB_NODE_CONNECTION_INFORMATION_EX
            NodeConnection.ConnectionIndex = PortNumber
            Marshal.StructureToPtr(NodeConnection, ptrNodeConnection, True)

            ' let's check to see if there is something plugged in first
            If DeviceIoControl(hHub, IOCTL_USB_GET_NODE_CONNECTION_INFORMATION_EX, ptrNodeConnection, nBytes, ptrNodeConnection, nBytes, nBytesReturned, IntPtr.Zero) Then
                NodeConnection = CType(Marshal.PtrToStructure(ptrNodeConnection, GetType(USB_NODE_CONNECTION_INFORMATION_EX)), USB_NODE_CONNECTION_INFORMATION_EX)

                If NodeConnection.ConnectionStatus = USB_CONNECTION_STATUS.DeviceConnected Then

                    ' now let's get the Driver Key Name
                    Dim DriverKey As New USB_NODE_CONNECTION_DRIVERKEY_NAME
                    DriverKey.ConnectionIndex = PortNumber
                    nBytes = Marshal.SizeOf(DriverKey)
                    Dim ptrDriverKey As IntPtr = Marshal.AllocHGlobal(nBytes)
                    Marshal.StructureToPtr(DriverKey, ptrDriverKey, True)

                    'Use an IOCTL call to request the Driver Key Name
                    If DeviceIoControl(hHub, IOCTL_USB_GET_NODE_CONNECTION_DRIVERKEY_NAME, ptrDriverKey, nBytes, ptrDriverKey, nBytes, nBytesReturned, IntPtr.Zero) Then
                        DriverKey = CType(Marshal.PtrToStructure(ptrDriverKey, GetType(USB_NODE_CONNECTION_DRIVERKEY_NAME)), USB_NODE_CONNECTION_DRIVERKEY_NAME)
                        ans = DriverKey.DriverKeyName
                    End If
                    Marshal.FreeHGlobal(ptrDriverKey)
                End If
            End If

            ' Clean up and go home
            Marshal.FreeHGlobal(ptrNodeConnection)
            CloseHandle(hHub)
        End If

        Return ans
    End Function

    '
    ' An internal routine to get the number of ports on a hub
    ' Used in Step 3
    '
    Private Function GetPortCount(ByVal HubDevicePath As String) As Integer
        Dim ans As Integer = 0

        ' open a connection to the HubDevice (that we just found)
        Dim hHub As IntPtr = CreateFile(HubDevicePath, GENERIC_WRITE, FILE_SHARE_WRITE, IntPtr.Zero, OPEN_EXISTING, 0, IntPtr.Zero)
        If hHub.ToInt32 <> INVALID_HANDLE_VALUE Then
            Dim nBytesReturned As Integer = 0
            Dim NodeInfo As New USB_NODE_INFORMATION
            NodeInfo.NodeType = USB_HUB_NODE.UsbHub
            Dim nBytes As Integer = Marshal.SizeOf(NodeInfo)
            Dim ptrNodeInfo As IntPtr = Marshal.AllocHGlobal(nBytes)
            Marshal.StructureToPtr(NodeInfo, ptrNodeInfo, True)

            ' get the number of ports on the hub
            If DeviceIoControl(hHub, IOCTL_USB_GET_NODE_INFORMATION, ptrNodeInfo, nBytes, ptrNodeInfo, nBytes, nBytesReturned, IntPtr.Zero) Then
                NodeInfo = CType(Marshal.PtrToStructure(ptrNodeInfo, GetType(USB_NODE_INFORMATION)), USB_NODE_INFORMATION)
                ans = NodeInfo.HubInformation.HubDescriptor.bNumberOfPorts
            End If

            Marshal.FreeHGlobal(ptrNodeInfo)
            CloseHandle(hHub)
        End If

        Return ans
    End Function

    '
    ' An internal routine to get the InstanceID of a device given its DriverKeyName
    ' Used in Step 3
    '
    Private Function FindInstanceIDByKeyName(ByVal DriverKeyName As String) As String
        Dim ans As String = ""
        Dim DevEnum As String = REGSTR_KEY_USB

        ' Use the "enumerator form" of the SetupDiGetClassDevs API 
        ' to generate a list of all USB devices
        Dim h As IntPtr = SetupDiGetClassDevs(0, DevEnum, IntPtr.Zero, DIGCF_PRESENT Or DIGCF_ALLCLASSES)
        If h.ToInt32 <> INVALID_HANDLE_VALUE Then
            Dim ptrBuf As IntPtr = Marshal.AllocHGlobal(BUFFER_SIZE)
            Dim KeyName As String
            Dim Success As Boolean
            Dim i As Integer = 0

            Do
                ' create a Device Interface Data structure
                Dim da As New SP_DEVINFO_DATA
                da.cbSize = Marshal.SizeOf(da)

                ' start the enumeration 
                Success = SetupDiEnumDeviceInfo(h, i, da)
                If Success Then
                    Dim RequiredSize As Integer = 0
                    Dim RegType As Integer = REG_SZ

                    KeyName = ""
                    ' get the driver key name
                    If SetupDiGetDeviceRegistryProperty(h, da, SPDRP_DRIVER, RegType, ptrBuf, BUFFER_SIZE, RequiredSize) Then
                        KeyName = Marshal.PtrToStringAuto(ptrBuf)
                    End If

                    ' do we have a match?
                    If KeyName = DriverKeyName Then
                        Dim nBytes As Integer = BUFFER_SIZE
                        Dim sb As New StringBuilder(nBytes)

                        SetupDiGetDeviceInstanceId(h, da, sb, nBytes, RequiredSize)
                        ans = sb.ToString()
                        Exit Do
                    End If
                End If
                i += 1
            Loop While Success

            CloseHandle(ptrBuf)
            SetupDiDestroyDeviceInfoList(h)
        End If

        Return ans
    End Function

    '
    ' An internal routine to get the DeviceDescriptor of a device given it's HubPath and PortNumber
    ' Handles Step 4
    '
    Private Function GetDeviceDescriptor(ByVal HubPath As String, ByVal PortNumber As Integer) As USB_DEVICE_DESCRIPTOR
        Dim ans As New USB_DEVICE_DESCRIPTOR
        Dim hHub, ptrDescReq, ptrDevDesc As IntPtr
        Dim DescReq As New USB_DESCRIPTOR_REQUEST
        Dim DevDesc As New USB_DEVICE_DESCRIPTOR
        Dim nBytesReturned, nBytes As Integer

        ' open a handle to the USB hub
        hHub = CreateFile(HubPath, GENERIC_WRITE, FILE_SHARE_WRITE, IntPtr.Zero, OPEN_EXISTING, 0, IntPtr.Zero)
        If hHub.ToInt32 <> INVALID_HANDLE_VALUE Then
            nBytes = BUFFER_SIZE

            ' build a "request" packet for a Device Descriptor
            DescReq = New USB_DESCRIPTOR_REQUEST
            DescReq.ConnectionIndex = PortNumber ' the "port number" on the hub
            DescReq.SetupPacket.wValue = USB_DEVICE_DESCRIPTOR_TYPE << 8
            DescReq.SetupPacket.wLength = CShort(nBytes - Marshal.SizeOf(DescReq))
            ptrDescReq = Marshal.AllocHGlobal(BUFFER_SIZE)
            Marshal.StructureToPtr(DescReq, ptrDescReq, True)

            ' Use an IOCTL call to request the Device Descriptor
            If DeviceIoControl(hHub, IOCTL_USB_GET_DESCRIPTOR_FROM_NODE_CONNECTION, ptrDescReq, nBytes, ptrDescReq, nBytes, nBytesReturned, IntPtr.Zero) Then
                ' the pointer to the Device Descriptor is just "off the edge" of
                ' the descriptor request packet.
                ptrDevDesc = New IntPtr(ptrDescReq.ToInt32 + Marshal.SizeOf(DescReq))
                ans = CType(Marshal.PtrToStructure(ptrDevDesc, GetType(USB_DEVICE_DESCRIPTOR)), USB_DEVICE_DESCRIPTOR)
            End If

            ' Clean up and go home
            Marshal.FreeHGlobal(ptrDescReq)
            CloseHandle(hHub)
        End If

        Return ans
    End Function

    '
    ' An internal routine to get the StringDescriptor of a device given it's HubPath, PortNumber, and string index
    ' Handles Step 5
    '
    Private Function GetStringDescriptor(ByVal HubPath As String, ByVal PortNumber As Integer, ByVal Index As Integer) As String
        Dim ans As String = ""
        Dim hHub, ptrDescReq, ptrStrDesc As IntPtr
        Dim DescReq As New USB_DESCRIPTOR_REQUEST
        Dim StrDesc As New USB_STRING_DESCRIPTOR
        Dim nBytesReturned, nBytes As Integer

        ' open a handle to the USB hub
        hHub = CreateFile(HubPath, GENERIC_WRITE, FILE_SHARE_WRITE, IntPtr.Zero, OPEN_EXISTING, 0, IntPtr.Zero)
        If hHub.ToInt32 <> INVALID_HANDLE_VALUE Then
            nBytes = BUFFER_SIZE

            ' build a "request" packet for a StringDescriptor
            DescReq = New USB_DESCRIPTOR_REQUEST
            DescReq.ConnectionIndex = PortNumber
            DescReq.SetupPacket.wValue = CShort((USB_STRING_DESCRIPTOR_TYPE << 8) + Index)
            DescReq.SetupPacket.wLength = CShort(nBytes - Marshal.SizeOf(DescReq))
            DescReq.SetupPacket.wIndex = &H409 ' Language Code

            ' we have to be a bit creative on how we "zero out" the buffer
            Dim NullString As New String(Chr(0), BUFFER_SIZE \ Marshal.SystemDefaultCharSize)
            ptrDescReq = Marshal.StringToHGlobalAuto(NullString)
            Marshal.StructureToPtr(DescReq, ptrDescReq, True)

            ' Use an IOCTL call to request the String Descriptor
            If DeviceIoControl(hHub, IOCTL_USB_GET_DESCRIPTOR_FROM_NODE_CONNECTION, ptrDescReq, nBytes, ptrDescReq, nBytes, nBytesReturned, IntPtr.Zero) Then
                ' the pointer to the String Descriptor is just "off the edge" of
                ' the descriptor request packet.
                ptrStrDesc = New IntPtr(ptrDescReq.ToInt32 + Marshal.SizeOf(DescReq))
                StrDesc = CType(Marshal.PtrToStructure(ptrStrDesc, GetType(USB_STRING_DESCRIPTOR)), USB_STRING_DESCRIPTOR)
                ans = StrDesc.bString
            End If

            ' Clean up and go home
            Marshal.FreeHGlobal(ptrDescReq)
            CloseHandle(hHub)
        End If

        Return ans
    End Function
End Class
