Public Class fmMain

    Private Sub fmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim Drive As IO.DriveInfo

        ' fill the combo box with the available drive letters
        For Each Drive In My.Computer.FileSystem.Drives
            If Drive.DriveType = IO.DriveType.Removable Or Drive.DriveType = IO.DriveType.Fixed Then
                cbxDriveLetters.Items.Add(Drive.Name.TrimEnd("\"c))
            End If
        Next

    End Sub

    Private Sub bnDoAPI_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnDoAPI.Click
        Dim usb As New USB_Serial
        Dim ans As String

        ' some quick sanity checking...
        If cbxDriveLetters.Text = "" Then
            MsgBox("Hey, you forgot to select a drive letter")
            Exit Sub
        End If

        Try
            ans = usb.GetSerialNumber(cbxDriveLetters.Text)
            MsgBox(ans)
        Catch ex As Exception
            MsgBox("Ooops, something went wrong" & vbCr & ex.Message & vbCr & ex.StackTrace, MsgBoxStyle.Exclamation, "Error")
            If Not IsNothing(ex.InnerException) Then
                MsgBox(ex.InnerException.Message & vbCr & ex.InnerException.StackTrace, MsgBoxStyle.Exclamation, "Error")
            End If
        End Try
    End Sub

    Private Sub bnDoWMI_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnDoWMI.Click
        Dim usb As New USB_Serial2
        Dim ans As String

        ' some quick sanity checking...
        If cbxDriveLetters.Text = "" Then
            MsgBox("Hey, you forgot to select a drive letter")
            Exit Sub
        End If

        Try
            ans = usb.GetSerialNumber(cbxDriveLetters.Text)
            MsgBox(ans)
        Catch ex As Exception
            MsgBox("Ooops, something went wrong" & vbCr & ex.Message & vbCr & ex.StackTrace, MsgBoxStyle.Exclamation, "Error")
        End Try
    End Sub

    Private Sub bnQuit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnQuit.Click
        Me.Close()
    End Sub
End Class
